/***************************************************************************
* COPYRIGHT NOTICE
* Copyright 2019 Horizon Robotics, Inc.
* All rights reserved.
***************************************************************************/
#ifndef __HB_ISP_IOCTL_H__
#define __HB_ISP_IOCTL_H__ /*PRQA S 0603*/ /*macro*/

#include "hb_comm_isp.h"

#ifdef __cplusplus
#if __cplusplus
extern "C"{
#endif
#endif /* __cplusplus */

typedef enum hbIOC_NR_ISP_E
{
    IOC_NR_ISP_SET_FD = 0,

	IOC_NR_ISP_SET_DEV_SCHED_MODE,
	IOC_NR_ISP_SET_ATTACH_STATUS,
	IOC_NR_ISP_GET_ATTACH_STATUS,
    IOC_NR_ISP_SET_PUB_ATTR,
    IOC_NR_ISP_GET_PUB_ATTR,
	IOC_NR_ISP_PIPE_START,
	IOC_NR_ISP_PIPE_STOP,
	IOC_NR_ISP_PIPE_INIT,
	IOC_NR_ISP_PIPE_EXIT,
	IOC_NR_ISP_RUN_ALGO,
	IOC_NR_ISP_RUN_ALGO_ONCE,
	IOC_NR_ISP_SET_MODULE_CONTROL,
	IOC_NR_ISP_GET_MODULE_CONTROL,
	IOC_NR_ISP_GET_AE_STAT,
	IOC_NR_ISP_RELEASE_AE_STAT,
	IOC_NR_ISP_GET_AWB_STAT,
	IOC_NR_ISP_RELEASE_AWB_STAT,
	IOC_NR_ISP_SET_LOG_LEVEL,
	IOC_NR_ISP_GET_LOG_LEVEL,
	IOC_NR_ISP_ENABLE_FRAME,
	IOC_NR_ISP_DISABLE_FRAME,
	IOC_NR_ISP_GET_FRAME,
	IOC_NR_ISP_RELEASE_FRAME,
	IOC_NR_ISP_REG_READ,
	IOC_NR_ISP_REG_WRITE,
	IOC_NR_ISP_SET_OUTPUT_ATTR,
	IOC_NR_ISP_GET_OUTPUT_ATTR,
	IOC_NR_ISP_SET_INPUT_FRAME,
	IOC_NR_ISP_GET_INPUT_FRAME,
	IOC_NR_ISP_CMD_API,
	IOC_NR_ISP_SET_AE_STATISTICS_ATTR,
	IOC_NR_ISP_GET_AE_STATISTICS_ATTR,
	IOC_NR_ISP_SET_AE_INFO,
	IOC_NR_ISP_GET_AE_INFO,
	IOC_NR_ISP_SET_AWB_STATISTICS_ATTR,
	IOC_NR_ISP_GET_AWB_STATISTICS_ATTR,
	IOC_NR_ISP_SET_WB_INFO,
	IOC_NR_ISP_GET_WB_INFO,
	IOC_NR_ISP_GET_CONTEXT,
	IOC_NR_ISP_GET_CONTEXT_NOCACHE,
	IOC_NR_ISP_FREE_CONTEXT,
	IOC_NR_ISP_GET_ISP_INFO,
	IOC_NR_ISP_CALIB_API,
	IOC_NR_ISP_LUT_REG_WR,
	IOC_NR_ISP_BUTT,
} IOC_NR_ISP_E; /*PRQA S ALL*/


#define IOC_TYPE_ISP   'I'

#define ISP_DEV_SET_FD				_IOW(IOC_TYPE_ISP, IOC_NR_ISP_SET_FD, uint64_t)

#define ISP_SET_DEV_SCHED_MODE		_IOW(IOC_TYPE_ISP, IOC_NR_ISP_SET_DEV_SCHED_MODE, isp_dev_sched_mode_e)

#define ISP_SET_ATTACH_STATUS		_IOW(IOC_TYPE_ISP, IOC_NR_ISP_SET_ATTACH_STATUS, isp_attach_pipe_t)
#define ISP_GET_ATTACH_STATUS		_IOR(IOC_TYPE_ISP, IOC_NR_ISP_GET_ATTACH_STATUS, isp_attach_pipe_t)

#define ISP_SET_PUB_ATTR			_IOW(IOC_TYPE_ISP, IOC_NR_ISP_SET_PUB_ATTR, isp_pub_attr_t)
#define ISP_GET_PUB_ATTR			_IOR(IOC_TYPE_ISP, IOC_NR_ISP_GET_PUB_ATTR, isp_pub_attr_t)

#define ISP_PIPE_INIT				_IO(IOC_TYPE_ISP, IOC_NR_ISP_PIPE_INIT)
#define ISP_PIPE_EXIT				_IO(IOC_TYPE_ISP, IOC_NR_ISP_PIPE_EXIT)
#define ISP_PIPE_START              _IOW(IOC_TYPE_ISP, IOC_NR_ISP_PIPE_START, uint32_t)
#define ISP_PIPE_STOP               _IOR(IOC_TYPE_ISP, IOC_NR_ISP_PIPE_STOP, uint32_t)

#define ISP_RUN_ALGO				_IO(IOC_TYPE_ISP, IOC_NR_ISP_RUN_ALGO)
#define ISP_RUN_ALGO_ONCE			_IO(IOC_TYPE_ISP, IOC_NR_ISP_RUN_ALGO_ONCE)

#define ISP_SET_MODULE_CONTROL		_IOW(IOC_TYPE_ISP, IOC_NR_ISP_SET_MODULE_CONTROL, isp_module_ctrl_u)
#define ISP_GET_MODULE_CONTROL		_IOR(IOC_TYPE_ISP, IOC_NR_ISP_GET_MODULE_CONTROL, isp_module_ctrl_u)

#define ISP_GET_AE_STAT				_IOWR(IOC_TYPE_ISP, IOC_NR_ISP_GET_AE_STAT, isp_ae_time_statistics_t)
#define ISP_RELEASE_AE_STAT			_IOWR(IOC_TYPE_ISP, IOC_NR_ISP_RELEASE_AE_STAT, isp_ae_time_statistics_t)

#define ISP_GET_AWB_STAT			_IOWR(IOC_TYPE_ISP, IOC_NR_ISP_GET_AWB_STAT, isp_awb_time_statistics_t)
#define ISP_RELEASE_AWB_STAT		_IOWR(IOC_TYPE_ISP, IOC_NR_ISP_RELEASE_AWB_STAT, isp_awb_time_statistics_t)

#define ISP_SET_LOG_LEVEL			_IOW(IOC_TYPE_ISP, IOC_NR_ISP_SET_LOG_LEVEL, isp_log_level_e)
#define ISP_GET_LOG_LEVEL			_IOR(IOC_TYPE_ISP, IOC_NR_ISP_GET_LOG_LEVEL, isp_log_level_e)

#define ISP_GET_FRAME				_IOWR(IOC_TYPE_ISP, IOC_NR_ISP_GET_FRAME, isp_frame_info_time_t)
#define ISP_RELEASE_FRAME			_IOWR(IOC_TYPE_ISP, IOC_NR_ISP_RELEASE_FRAME, isp_frame_info_t)

#define ISP_REG_READ				_IOWR(IOC_TYPE_ISP, IOC_NR_ISP_REG_READ, isp_reg_t)
#define ISP_REG_WRITE               _IOW(IOC_TYPE_ISP, IOC_NR_ISP_REG_WRITE, isp_reg_t)

#define ISP_SET_OUTPUT_ATTR			_IOW(IOC_TYPE_ISP, IOC_NR_ISP_SET_OUTPUT_ATTR, isp_output_attr_t)
#define ISP_GET_OUTPUT_ATTR			_IOR(IOC_TYPE_ISP, IOC_NR_ISP_GET_OUTPUT_ATTR, isp_output_attr_t)

#define ISP_SET_INPUT_FRAME			_IOW(IOC_TYPE_ISP, IOC_NR_ISP_SET_INPUT_FRAME, isp_frame_info_t)
#define ISP_GET_INPUT_FRAME			_IOR(IOC_TYPE_ISP, IOC_NR_ISP_GET_INPUT_FRAME, isp_frame_info_t)

#define ISP_CMD_API					_IOWR(IOC_TYPE_ISP, IOC_NR_ISP_CMD_API, isp_cmd_api_t)

#define ISP_SET_AE_STATISTICS_ATTR	_IOW(IOC_TYPE_ISP, IOC_NR_ISP_SET_AE_STATISTICS_ATTR, isp_ae_statistics_attr_t)
#define ISP_GET_AE_STATISTICS_ATTR	_IOR(IOC_TYPE_ISP, IOC_NR_ISP_GET_AE_STATISTICS_ATTR, isp_ae_statistics_attr_t)
#define ISP_SET_AE_INFO				_IOW(IOC_TYPE_ISP, IOC_NR_ISP_SET_AE_INFO, ae_info_t)
#define ISP_GET_AE_INFO				_IOR(IOC_TYPE_ISP, IOC_NR_ISP_GET_AE_INFO, ae_info_t)

#define ISP_SET_AWB_STATISTICS_ATTR	_IOW(IOC_TYPE_ISP, IOC_NR_ISP_SET_AWB_STATISTICS_ATTR, isp_awb_statistics_attr_t)
#define ISP_GET_AWB_STATISTICS_ATTR	_IOR(IOC_TYPE_ISP, IOC_NR_ISP_GET_AWB_STATISTICS_ATTR, isp_awb_statistics_attr_t)
#define ISP_SET_WB_INFO			_IOW(IOC_TYPE_ISP, IOC_NR_ISP_SET_WB_INFO, awb_info_t)
#define ISP_GET_WB_INFO				_IOR(IOC_TYPE_ISP, IOC_NR_ISP_GET_WB_INFO, awb_info_t)

#define ISP_GET_CONTEXT_NOCACHE      _IOR(IOC_TYPE_ISP, IOC_NR_ISP_GET_CONTEXT_NOCACHE, isp_context_info_t)
#define ISP_FREE_CONTEXT            _IO(IOC_TYPE_ISP, IOC_NR_ISP_FREE_CONTEXT)
#define ISP_GET_CONTEXT				_IOR(IOC_TYPE_ISP, IOC_NR_ISP_GET_CONTEXT, isp_context_info_t)
#define ISP_GET_ISP_INFO			_IOR(IOC_TYPE_ISP, IOC_NR_ISP_GET_ISP_INFO, isp_info_time_t)

#define ISP_CALIB_API                           _IOWR(IOC_TYPE_ISP, IOC_NR_ISP_CALIB_API, isp_calib_lut_t)
#define ISP_LUT_REG_WR                          _IOWR(IOC_TYPE_ISP, IOC_NR_ISP_LUT_REG_WR, isp_lut_reg_t)

#ifdef __cplusplus
#if __cplusplus
}
#endif
#endif /* __cplusplus */

#endif /* __HB_TYPE_H__ */
