/*
 *    COPYRIGHT NOTICE
 *    Copyright 2022 Horizon Robotics, Inc.
 *    All rights reserved.
 */
#ifndef OTA_UTILITY_UPDATE_INCLUDE_UPDATE_H_
#define OTA_UTILITY_UPDATE_INCLUDE_UPDATE_H_

#ifdef __cplusplus
extern "C" {
#endif

enum ota_update_error_type {
  REPEAT_INIT_ERR = 0xef00,
  INIT_FAILED_ERR,
  DEINIT_FAILED_ERR,
  GET_LIB_VERSION_ERR,
  UPDATE_START_ERR,
  GET_RESULT_ERR,
  GET_PROCESS_ERR,
  GET_VERSION_ERR,
  GET_PARTITION_ERR,
  SET_PARTITION_ERR,
  GET_IMAGE_NAME_ERR,
  UPDATE_STOP_ERR
};

int ota_update_lib_init(void);

int ota_update_lib_deinit(void);

int ota_update_request_start(char *image_name);

int ota_update_get_result(void);

int ota_update_get_process(void);

int ota_update_get_version(char *version, int len);

int ota_update_get_partition(char *partition);

int ota_update_set_partition(char partition);

int ota_update_get_image_name(char *image_name, int len);

#ifdef __cplusplus
}
#endif

#endif // OTA_UTILITY_UPDATE_INCLUDE_UPDATE_H_